#!/bin/bash
# pager.sh v 0.1
# OpenLX USB Boot Downloader by PhilKll
# Know what you are doing first then use this
# No warranties :)

# Check for file name
if [ $# -eq 0 ]; then
	echo "Please specify a file name to upload."
	exit 1
fi
file_name=$1
echo "File to upload $file_name"

# File to send size in bytes
file_size=$(stat -c%s "$file_name")

# Number of 16,384 byte sized packets to send 
packets=$((file_size/16384))

# Counters
i=0
total=0
last_total=0

# Change LBA
first=0
byte1="00"

# Device
DISK_NAME=""



# Write file to device
write_firmware()
{
  	while [ $i -le $(($packets-1)) ]
	do
		sg_raw /dev/$DISK_NAME -b -s 16384 -n -k $last_total -i $file_name 2A 00 00 00 00 $byte1 00 00 20 00

		if [ "$first" -eq 0 ]; then
		byte1="01"
		fi

		total=$((last_total + 16383))
		echo "$i: Writing bytes:$last_total -> $total to /dev/$DISK_NAME" 
		last_total=$((total+1)) 
		i=$((i+1))
	done

	echo "Verifying /dev/$DISK_NAME"
	sg_verify /dev/$DISK_NAME
}

# Find Leapfrog device
for device in /sys/class/scsi_disk/*; do
        if [ `cat $device/device/vendor` = "Leapfrog" ]; then
                DISK_NAME="`ls $device/device/block/`"
        fi
done

# Check if device found
if [ "$DISK_NAME" = "" ]; then
        echo "Device not found"
        exit 1
fi
# Found and now write it
echo "Found /dev/$DISK_NAME"
write_firmware
